###########################################################################
#
#  Copyright 2021 Google LLC
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#      https://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.
#
###########################################################################

SA_FIELDS = {
  "status": "STRING",
  "creationTimestamp": "TIMESTAMP",
  "lastModifiedTimestamp": "TIMESTAMP",
  "agency": "STRING",
  "agencyId": "STRING",
  "advertiser": "STRING",
  "advertiserId": "STRING",
  "account": "STRING",
  "accountId": "STRING",
  "accountEngineId": "STRING",
  "accountType": "STRING",
  "accountCurrencyCode": "STRING",
  "accountTimeZone": "STRING",
  "dfaActions": "INTEGER",
  "dfaRevenue": "FLOAT",
  "dfaTransactions": "INTEGER",
  "dfaWeightedActions": "INTEGER",
  "dfaActionsCrossEnv": "INTEGER",
  "dfaRevenueCrossEnv": "FLOAT",
  "dfaTransactionsCrossEnv": "INTEGER",
  "dfaWeightedActionsCrossEnv": "INTEGER",
  "avgCpc": "FLOAT",
  "avgCpm": "FLOAT",
  "avgPos": "INTEGER",
  "clicks": "INTEGER",
  "cost": "FLOAT",
  "ctr": "INTEGER",
  "impr": "INTEGER",
  "adWordsConversions": "INTEGER",
  "adWordsConversionValue": "INTEGER",
  "adWordsViewThroughConversions": "INTEGER",
  "visits": "INTEGER",
  "searchImpressionShare": "STRING",
  "searchBudgetLostImpressionShare": "STRING",
  "searchRankLostImpressionShare": "STRING",
  "displayImpressionShare": "STRING",
  "displayBudgetLostImpressionShare": "STRING",
  "displayRankLostImpressionShare": "STRING",
  "qualityScoreAvg": "INTEGER",
  "topOfPageBidAvg": "FLOAT",
  "absoluteTopImpressionPercentage": "STRING",
  "searchAbsoluteTopImpressionShare": "STRING",
  "topImpressionPercentage": "STRING",
  "searchTopImpressionShare": "STRING",
  "searchBudgetLostAbsoluteTopImpressionShare": "STRING",
  "searchBudgetLostTopImpressionShare": "STRING",
  "searchRankLostAbsoluteTopImpressionShare": "STRING",
  "searchRankLostTopImpressionShare": "STRING",
  "date": "DATE",
  "monthStart": "DATE",
  "monthEnd": "DATE",
  "quarterStart": "DATE",
  "quarterEnd": "DATE",
  "weekStart": "DATE",
  "weekEnd": "DATE",
  "yearStart": "DATE",
  "yearEnd": "DATE",
  "deviceSegment": "STRING",
  "floodlightGroup": "STRING",
  "floodlightGroupId": "STRING",
  "floodlightGroupTag": "STRING",
  "floodlightActivity": "STRING",
  "floodlightActivityId": "STRING",
  "floodlightActivityTag": "STRING",
  "engineStatus": "STRING",
  "campaign": "STRING",
  "campaignId": "STRING",
  "campaignStatus": "STRING",
  "adGroup": "STRING",
  "adGroupId": "STRING",
  "adGroupStatus": "STRING",
  "ad": "STRING",
  "adId": "STRING",
  "adEngineId": "STRING",
  "isUnattributedAd": "BOOLEAN",
  "adHeadline": "STRING",
  "adHeadline2": "STRING",
  "adHeadline3": "STRING",
  "adDescription1": "STRING",
  "adDescription2": "STRING",
  "adDisplayUrl": "STRING",
  "adLandingPage": "STRING",
  "adType": "STRING",
  "adPromotionLine": "STRING",
  "adLabels": "STRING",
  "adPathField1": "STRING",
  "adPathField2": "STRING",
  "effectiveLabels": "STRING",
  "dfaAdvertiserId": "STRING",
  "dfaNetworkId": "STRING",
  "dfaNetworkTimeZone": "STRING",
  "advertiserCurrencyCode": "STRING",
  "googleAnalyticsTimeZone": "STRING",
  "adRotation": "STRING",
  "adGroupEngineId": "STRING",
  "adGroupStartDate": "DATE",
  "adGroupEndDate": "DATE",
  "adGroupSearchMaxCpc": "FLOAT",
  "adGroupBroadMaxCpc": "FLOAT",
  "adGroupExactMaxCpc": "FLOAT",
  "adGroupPhraseMaxCpc": "FLOAT",
  "adGroupContentMaxCpc": "FLOAT",
  "adGroupMobileBidAdjustment": "INTEGER",
  "adGroupTabletBidAdjustment": "INTEGER",
  "adGroupDesktopBidAdjustment": "INTEGER",
  "adGroupType": "STRING",
  "bingAdsLanguage": "STRING",
  "bingAdsAdDistributions": "STRING",
  "adGroupLabels": "STRING",
  "effectiveBidStrategyId": "STRING",
  "effectiveBidStrategy": "STRING",
  "bidStrategyInherited": "BOOLEAN",
  "deviceTargets": "STRING",
  "effectiveDeviceTargets": "STRING",
  "countryTargets": "STRING",
  "provinceTargets": "STRING",
  "metroTargets": "STRING",
  "cityTargets": "STRING",
  "effectiveCountryTargets": "STRING",
  "effectiveProvinceTargets": "STRING",
  "effectiveMetroTargets": "STRING",
  "effectiveCityTargets": "STRING",
  "engineRemarketingListTargetAll": "BOOLEAN",
  "clicksWithFeedItemShowing": "INTEGER",
  "costWithFeedItemShowing": "FLOAT",
  "sitelinkDisplayText": "STRING",
  "sitelinkDescription1": "STRING",
  "sitelinkDescription2": "STRING",
  "sitelinkLandingPageUrl": "STRING",
  "sitelinkClickserverUrl": "STRING",
  "locationBusinessName": "STRING",
  "locationCategory": "STRING",
  "locationDetails": "STRING",
  "locationFilter": "STRING",
  "callPhoneNumber": "STRING",
  "callCountryCode": "STRING",
  "callIsTracked": "BOOLEAN",
  "callCallOnly": "BOOLEAN",
  "callConversionTracker": "STRING",
  "callConversionTrackerId": "STRING",
  "appId": "STRING",
  "appStore": "STRING",
  "feedItemId": "STRING",
  "feedId": "STRING",
  "feedType": "STRING",
  "engineRemarketingList": "STRING",
  "engineRemarketingListBidModifier": "INTEGER",
  "dynamicSearchAdsTargetConditions": "STRING",
  "dynamicSearchAdsTargetCpcBid": "FLOAT",
  "dynamicSearchAdsTargetLandingPageUrl": "STRING",
  "dynamicSearchAdsTargetCoverage": "INTEGER",
  "locationTargetName": "STRING",
  "locationTargetBidModifier": "INTEGER",
  "ageTargetAgeRange": "STRING",
  "ageTargetBidModifier": "INTEGER",
  "genderTargetGenderType": "STRING",
  "genderTargetBidModifier": "INTEGER",
  "unclassifiedTargetName": "STRING",
  "unclassifiedTargetType": "STRING",
  "adGroupTargetId": "STRING",
  "bidStrategyId": "STRING",
  "bidStrategy": "STRING",
  "bidStrategyGoal": "STRING",
  "floodlightOptimizationEnabled": "BOOLEAN",
  "ersTarget": "INTEGER",
  "cpaTarget": "FLOAT",
  "roasTarget": "INTEGER",
  "lowPosition": "INTEGER",
  "highPosition": "INTEGER",
  "bidStrategyMinBid": "FLOAT",
  "bidStrategyMaxBid": "FLOAT",
  "monthlySpendTarget": "FLOAT",
  "floodlightActivityTargetIds": "STRING",
  "campaignEngineId": "STRING",
  "campaignStartDate": "DATE",
  "campaignEndDate": "DATE",
  "bingAdsBudgetType": "STRING",
  "dailyBudget": "FLOAT",
  "monthlyBudget": "FLOAT",
  "deliveryMethod": "STRING",
  "adWordsBidStrategy": "STRING",
  "yahooJapanBidStrategy": "STRING",
  "keywordNearMatchEnabled": "STRING",
  "campaignMobileBidAdjustment": "INTEGER",
  "campaignTabletBidAdjustment": "INTEGER",
  "campaignDesktopBidAdjustment": "INTEGER",
  "networkTarget": "STRING",
  "yahooGeoTargets": "STRING",
  "campaignLabels": "STRING",
  "campaignType": "STRING",
  "languageTargets": "STRING",
  "excludedCountryTargets": "STRING",
  "excludedProvinceTargets": "STRING",
  "excludedMetroTargets": "STRING",
  "excludedCityTargets": "STRING",
  "campaignTargetId": "STRING",
  "floodlightGroupConversionType": "STRING",
  "keywordId": "STRING",
  "keywordMatchType": "STRING",
  "keywordText": "STRING",
  "productTargetId": "STRING",
  "productGroupId": "STRING",
  "inventoryAccountId": "STRING",
  "productId": "STRING",
  "productCountry": "STRING",
  "productLanguage": "STRING",
  "productStoreId": "STRING",
  "productChannel": "STRING",
  "conversionId": "STRING",
  "advertiserConversionId": "STRING",
  "conversionType": "STRING",
  "conversionRevenue": "FLOAT",
  "conversionQuantity": "INTEGER",
  "conversionDate": "DATE",
  "conversionTimestamp": "TIMESTAMP",
  "conversionLastModifiedTimestamp": "TIMESTAMP",
  "conversionAttributionType": "STRING",
  "conversionVisitId": "STRING",
  "conversionVisitTimestamp": "TIMESTAMP",
  "conversionVisitExternalClickId": "STRING",
  "conversionSearchTerm": "STRING",
  "floodlightOriginalRevenue": "FLOAT",
  "floodlightEventRequestString": "STRING",
  "floodlightReferrer": "STRING",
  "floodlightOrderId": "STRING",
  "floodlightConfigurationId": "STRING",
  "keywordEngineId": "STRING",
  "keywordMaxCpc": "FLOAT",
  "effectiveKeywordMaxCpc": "FLOAT",
  "keywordLandingPage": "STRING",
  "keywordClickserverUrl": "STRING",
  "isDisplayKeyword": "BOOLEAN",
  "keywordMaxBid": "FLOAT",
  "keywordMinBid": "FLOAT",
  "keywordUrlParams": "STRING",
  "bingKeywordParam2": "STRING",
  "bingKeywordParam3": "STRING",
  "keywordLabels": "STRING",
  "qualityScoreCurrent": "INTEGER",
  "topOfPageBidCurrent": "FLOAT",
  "negativeAdGroupKeywordId": "STRING",
  "negativeAdGroupKeywordText": "STRING",
  "negativeAdGroupKeywordMatchType": "STRING",
  "negativeAdGroupTargetId": "STRING",
  "negativeCampaignKeywordId": "STRING",
  "negativeCampaignKeywordText": "STRING",
  "negativeCampaignKeywordMatchType": "STRING",
  "negativeCampaignTargetId": "STRING",
  "searchQuery": "STRING",
  "serpType": "STRING",
  "paidClicks": "INTEGER",
  "organicClicks": "INTEGER",
  "paidAndOrganicClicks": "INTEGER",
  "paidImpressions": "INTEGER",
  "organicQueries": "INTEGER",
  "paidAndOrganicQueries": "INTEGER",
  "paidCtr": "INTEGER",
  "organicCtr": "INTEGER",
  "paidAndOrganicCtr": "INTEGER",
  "paidAvgPos": "INTEGER",
  "organicAvgPos": "INTEGER",
  "paidCostPerClick": "FLOAT",
  "productMpn": "STRING",
  "productColor": "STRING",
  "productSize": "STRING",
  "productMaterial": "STRING",
  "productPattern": "STRING",
  "productAvailability": "STRING",
  "productGender": "STRING",
  "productAgeGroup": "STRING",
  "productLandingPageUrl": "STRING",
  "productCategory": "STRING",
  "productCategoryLevel1": "STRING",
  "productCategoryLevel2": "STRING",
  "productCategoryLevel3": "STRING",
  "productCategoryLevel4": "STRING",
  "productCategoryLevel5": "STRING",
  "productBrand": "STRING",
  "productGtin": "STRING",
  "productPrice": "FLOAT",
  "productSalePrice": "FLOAT",
  "productTypeLevel1": "STRING",
  "productTypeLevel2": "STRING",
  "productTypeLevel3": "STRING",
  "productTypeLevel4": "STRING",
  "productTypeLevel5": "STRING",
  "productCondition": "STRING",
  "productCustomLabel0": "STRING",
  "productCustomLabel1": "STRING",
  "productCustomLabel2": "STRING",
  "productCustomLabel3": "STRING",
  "productCustomLabel4": "STRING",
  "productCostOfGoodsSold": "FLOAT",
  "productChannelExclusivity": "STRING",
  "productItemGroupId": "STRING",
  "productTitle": "STRING",
  "productGroup": "STRING",
  "productGroupPartitionType": "STRING",
  "productGroupLandingPage": "STRING",
  "productGroupClickserverUrl": "STRING",
  "productGroupMaxCpc": "FLOAT",
  "effectiveProductGroupMaxCpc": "FLOAT",
  "productGroupMaxBid": "FLOAT",
  "productGroupMinBid": "FLOAT",
  "crossSellAverageUnitPrice": "FLOAT",
  "crossSellCostOfGoodsSold": "FLOAT",
  "crossSellGrossFromUnitsSold": "FLOAT",
  "crossSellGrossProfitMargin": "INTEGER",
  "crossSellRevenueFromUnitsSold": "FLOAT",
  "crossSellUnitsSold": "INTEGER",
  "leadAverageUnitPrice": "FLOAT",
  "leadCostOfGoodsSold": "FLOAT",
  "leadGrossProfitFromUnitsSold": "FLOAT",
  "leadGrossProfitMargin": "INTEGER",
  "leadRevenueFromUnitsSold": "FLOAT",
  "leadUnitsSold": "INTEGER",
  "productUnitsSold": "INTEGER",
  "productRevenueFromUnitsSold": "FLOAT",
  "productAverageUnitPrice": "FLOAT",
  "productTargetFilter": "STRING",
  "productTargetEngineId": "STRING",
  "productTargetLandingPage": "STRING",
  "productTargetClickserverUrl": "STRING",
  "productTargetLabels": "STRING",
  "productTargetMaxCpc": "FLOAT",
  "effectiveProductTargetMaxCpc": "FLOAT",
  "productTargetMaxBid": "FLOAT",
  "productTargetMinBid": "FLOAT",
  "visitId": "STRING",
  "visitSearchQuery": "STRING",
  "visitDate": "DATE",
  "visitTimestamp": "TIMESTAMP",
  "visitNetworkType": "STRING",
  "visitReferrer": "STRING",
  "visitExternalClickId": "STRING"
}
